<template>
  <div class="wrapper">
    <the-header :score="score" class="header"></the-header>
    <board-game v-if="!isPicked" @pick="pick"></board-game>
    <battle-game
      v-else
      @play-again="playAgain"
      @get-result="getResult"
      :choice="choice"
    ></battle-game>
    <the-footer></the-footer>
  </div>
</template>

<script>
import TheHeader from "@/components/layout/TheHeader.vue";
import TheFooter from "@/components/layout/TheFooter.vue";
import BoardGame from "@/components/game/BoardGame.vue";
import BattleGame from "@/components/game/BattleGame.vue";

export default {
  components: {
    TheHeader,
    TheFooter,
    BoardGame,
    BattleGame,
  },
  data() {
    return {
      isPicked: false,
      choice: null,
      score: 0,
    };
  },
  mounted() {
    document.title = `Frontend Mentor | Rock-Paper-Scissors-Lizard-Spock`;
  },
  methods: {
    pick(choice) {
      this.isPicked = true;
      this.choice = choice;
    },
    playAgain() {
      this.isPicked = false;
    },
    getResult(result) {
      setTimeout(() => {
        this.score = this.score + result;
      }, 2000);
    },
  },
};
</script>

<style>
@import url("https://fonts.googleapis.com/css2?family=Barlow+Semi+Condensed:wght@600;700&display=swap");
/* ------------------- */
/* Custom properties   */
/* ------------------- */

:root {
  /* colors */
  --primary-scissor: linear-gradient(hsl(39, 89%, 49%), hsl(40, 84%, 53%));
  --primary-paper: linear-gradient(hsl(230, 89%, 62%), hsl(230, 89%, 65%));
  --primary-rock: linear-gradient(hsl(349, 71%, 52%), hsl(349, 70%, 56%));
  --primary-lizard: linear-gradient(hsl(261, 73%, 60%), hsl(261, 72%, 63%));
  --primary-spock: linear-gradient(hsl(189, 59%, 53%), hsl(189, 58%, 57%));

  --neutral-white: hsl(0, 0%, 100%);
  --neutral-dark: hsl(229, 25%, 31%);
  --neutral-score: hsl(229, 64%, 46%);
  --neutral-header: hsl(217, 16%, 45%);
  --background-gradient: radial-gradient(
    hsl(214, 47%, 23%),
    hsl(237, 49%, 15%)
  );

  --clr-bs-scissor: hsl(28, 75%, 45%);
  --clr-bs-paper: hsl(230, 66%, 45%);
  --clr-bs-rock: hsl(349, 77%, 35%);
  --clr-bs-lizard: hsl(261deg 67% 42%);
  --clr-bs-spock: hsl(189deg 68% 44%);
  /* font-sizes */
  --fs-body: 1rem;

  /* font-families */
  --ff-primary: "Barlow Semi Condensed", sans-serif;

  /* font-weights */
  --fw-600: 600;
  --fw-700: 700;
}

/* Box sizing rules */
*,
*::before,
*::after {
  box-sizing: border-box;
}

/* Remove default margin */
body,
h1,
h2,
h3,
h4,
p,
figure,
blockquote,
dl,
dd {
  margin: 0;
}

/* Remove list styles on ul, ol elements with a list role, which suggests default styling will be removed */
ul[role="list"],
ol[role="list"] {
  list-style: none;
}

/* Set core root defaults */
html:focus-within {
  scroll-behavior: smooth;
}

/* Set core body defaults */
body {
  min-height: 100vh;
  text-rendering: optimizeSpeed;
  line-height: 1.5;
}

/* A elements that don't have a class get default styles */
a:not([class]) {
  text-decoration-skip-ink: auto;
}

/* Make images easier to work with */
img,
picture {
  max-width: 100%;
  display: block;
}

/* Inherit fonts for inputs and buttons */
input,
button,
textarea,
select {
  font: inherit;
}

/* Remove all animations, transitions and smooth scroll for people that prefer not to see them */
@media (prefers-reduced-motion: reduce) {
  html:focus-within {
    scroll-behavior: auto;
  }

  *,
  *::before,
  *::after {
    animation-duration: 0.01ms !important;
    animation-iteration-count: 1 !important;
    transition-duration: 0.01ms !important;
    scroll-behavior: auto !important;
  }
}
/* ------------------- */
/* Utility classes     */
/* ------------------- */

/* general */
.flex {
  display: flex;
  gap: var(--gap, 1rem);
  align-items: center;
}

.grid {
  display: grid;
  gap: var(--gap, 1rem);
}

/* set up the body */
body {
  font-family: var(--ff-primary);
  font-size: var(--fs-body);
  background: var(--background-gradient);
  color: var(--neutral-white);
  overflow-x: hidden;
}
.wrapper {
  height: 100vh;
  display: grid;
  grid-template-rows: min-content 1fr min-content;
}
</style>
